<template>
  <div
    class="sprite"
    :style="`
      width: ${size}px;
      height: ${size}px;
      transform: scaleX(${flip ? -1 : 1});
      `"
  >
    <img
      :src="src"
      :style="`
        width: ${spritesheetCols * size}px;
        height: ${spritesheetRows * size}px;
        transform: translate(${-spritePos.x * size}px, ${
        -spritePos.y * size
      }px);
      `"
    />
  </div>
</template>

<script>
export default {
  props: {
    src: String,
    size: {
      type: Number,
      default: 96,
    },
    spritesheetRows: Number,
    spritesheetCols: Number,
    animations: Object,
    currentAnimation: String,
    flip: Boolean,
  },
  data() {
    return {
      pos: {
        x: 0,
        y: 0
      },
      spritePos: {
        x: 0,
        y: 0,
      },
      frameDuration: 1 / 8, // 8 frames per second
      animString: '',
      startFrame: 0,
      endFrame: 0,
      steps: 0,
      currentFrame: 0,
      timer: 0,
    };
  },
  methods: {
    update(deltaTime) {
      if (this.animString !== this.currentAnimation) {
        this.animString = this.currentAnimation;
        this.startFrame = this.animations[this.animString].start;
        this.currentFrame = this.animations[this.animString].start;
        this.endFrame = this.animations[this.animString].end;
        this.steps = this.endFrame - this.startFrame + 1;
      }

      this.currentFrame = this.startFrame + Math.floor(this.timer / this.frameDuration);

      if (this.currentFrame > this.endFrame) {
        this.currentFrame = this.startFrame;
      }

      this.spritePos.y = Math.floor(this.currentFrame / this.spritesheetRows);
      this.spritePos.x = this.currentFrame - this.spritePos.y * this.spritesheetCols;
      if (this.timer + deltaTime > this.steps * this.frameDuration) {
        this.timer -= (this.steps * this.frameDuration) - deltaTime;
      } else {
        this.timer += deltaTime;
      }
    },
  },
}
</script>

<style lang="scss">
.sprite {
  overflow: hidden;
  position: relative;

  img {
    width: 100%;
    height: 100%;
  }
}
</style>